﻿using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Linq;
using System.Text;
using System.Net;
using System.IO; 
using System.Threading;
//M using Mylib;
//M using Unmanaged;
using System.Runtime.InteropServices;

//M using ChrisLib;

// Minimal webserver implementation to support surgweb asking for long 
// polling new message notifications :-)
// http://ajlopez.wordpress.com/2011/02/01/a-minimal-http-server-in-c/
// http://bartdesmet.net/blogs/bart/archive/2007/02/22/httplistener-for-dummies-a-simple-http-request-reflector.aspx

namespace MidaCloud
{

    class WebServer
    {
        static HttpListener listener = null;
        static string rootDirectory;
        static bool exiting = false;
        public static void WebInit()
        {
            Thread newThread;
            newThread = new System.Threading.Thread(WebServer.run);
            newThread.Start();
        }
        
        const string Prefix = "http://+:9090/";

        private static void run()
        {
            if (!HttpListener.IsSupported) {
                Console.WriteLine("HttpListener is not supported on this platform.");
                return;
            }
            rootDirectory = "c:\\surgemail\\www";
            listener = new HttpListener();
            listener.Prefixes.Add(Prefix);
            listener.Start();
            IAsyncResult result = listener.BeginGetContext(ListenerCallback, null);
            for (;;) {
                if(exiting){
                    listener.Stop();
                    break;
                }
                Thread.Sleep(200);
            }
        }
        public static void exit_now()
        {
            exiting=true;
        }

        static int checkmail_uid = 0; 
        static int RequestNumber = 0;
        static readonly DateTime StartupDate = DateTime.UtcNow;
        static public void checkmail_setuid(int uid)
        {
            if(uid<=checkmail_uid) return;
            checkmail_uid = uid;
        }

        static void ListenerCallback(IAsyncResult result)
        {
            HttpListenerContext context;
           // OK handle the handover
            try{
                context = listener.EndGetContext(result);
            }
            catch{
                return;
            }
            listener.BeginGetContext(ListenerCallback, null);
            HttpListenerResponse response = context.Response;

            // Now we are safe and on our own :-)
            var NowTime = DateTime.UtcNow;
            int req = ++RequestNumber;
            string url_raw = context.Request.RawUrl;
            Console.WriteLine("{0}: {1}", NowTime.ToString("R"), context.Request.RawUrl);

            NameValueCollection query = clib.ParseQueryString(url_raw);
            string url=clib.url_decode(url_raw);

            bool cmd_found=false;
/*
            if (url.StartsWith("/compose")) {
                stat.imsg("new compose");
                Background.surgeweb_compose(query["email"]);
                webDone(response, 200);
                return;
            } else if (url.StartsWith("/contact_image")) {
                string face_file = Background.face_file(query["email"]);
                //if(!exists...)
                serveFile(response, face_file);
                return;
            } else if (url.StartsWith("/checkmail")) {
                WindowExtensions2.playWindows();
                cmd_found = true;
            }
*/
            string fname="";
            bool template=false;
            if(url=="/") { 
                web_redirect(context,"/cm/demo/basic.html"); 
                return;
            } else if (url.StartsWith("/cm")) {
                template=true;
                fname=clib.www_root(url);

            } else if (url.StartsWith("/files")) {
                fname = clib.www_root("/cm"+url.Substring(6));
                
            } else {
                // just try and server raw file
                fname=clib.www_root(url);
            }
            if (!File.Exists(fname)) {
                web_badfile(context);
                return;
            }            
            if (template){
                serveTemplateFile(response, fname);
            } else {
                serveFile(response, fname);
            }

            return;


            if (!cmd_found) {
                webDone(response, 404);
                return;
            }

            int timeout = clib.time() + 60;
            int knownuid = clib.atoi(query["knownuid"]);
            bool timed_out = false;
            if (knownuid>0) {
                for (;;) {
                    if (exiting) break;
                    if (checkmail_uid > knownuid) break;
                    if (clib.time() > timeout) { timed_out = true; break; }
                    Thread.Sleep(200);
                }
            }

            string responseString = "<HTML><BODY> Hello world!</BODY></HTML>";
            responseString  = String.Format("+{0}:{1}", (timed_out ? "TIMEOUT" : "NEWMSG"), checkmail_uid);
            byte[] buffer = Encoding.UTF8.GetBytes(responseString);

            System.IO.Stream output = response.OutputStream;
            response.ContentType = "text/html";
            response.ContentLength64 = buffer.Length;
            response.StatusCode = 200;
            response.AddHeader("Access-Control-Allow-Origin","*");

            try{
                output.Write(buffer, 0, buffer.Length);
                output.Close();
            }
            catch{
                clib.imsg("webserver write failure, ignoring");
            }
        }
        static private void webDone(HttpListenerResponse response, int status)
        {
            System.IO.Stream op = response.OutputStream;
            response.ContentLength64 = 0;
            response.StatusCode = status;
            op.Close();
        }
        static private void serveFile(HttpListenerResponse response, string fname)
        {
            string filename = fname;
            Stream input = new FileStream(filename, FileMode.Open);
            long len = input.Length;
            byte[] buffer = new byte[len];

            int nbytes;
            System.IO.Stream op = response.OutputStream;
            response.ContentType = clib.guess_type(fname);
            response.ContentLength64 = len;
            response.StatusCode = 200;
            while ((nbytes = input.Read(buffer, 0, buffer.Length)) > 0){
                response.OutputStream.Write(buffer, 0, nbytes);
            }
            input.Close();
            op.Close();
        }
        static private void serveTemplateFile(HttpListenerResponse response, string fname)
        {
            string filename = fname;
            bool removing_space=false;
  //          Stream input = new FileStream(filename, FileMode.Open);
  //          long len = input.Length;
            TextReader tr = new StreamReader(fname);
//            byte[] buffer = new byte[len];

//            int nbytes;
            System.IO.Stream op = response.OutputStream;
            response.ContentType = clib.guess_type(fname);
//            response.ContentLength64 = len;
            response.StatusCode = 200;
            for (; true; ) {
                string inbf = tr.ReadLine();
                if (inbf == null) break;
                if (inbf.StartsWith("# ") || inbf.StartsWith("#\t")) 
                    continue;
                if(removing_space){
                    inbf=inbf.TrimStart();
                    removing_space=false;
                }
                if (inbf.EndsWith("\\") && !(inbf.EndsWith("\\\\"))) {
                    inbf = inbf.Substring(0,inbf.Length-1);
                    removing_space=true;
                }

                byte[] arr = clib.string_to_byte(inbf);
                response.OutputStream.Write(arr, 0, arr.Length);
                
                if(removing_space) continue;

                byte[] arr2 = clib.string_to_byte("\n");
                response.OutputStream.Write(arr2, 0, arr2.Length);
            }
/*
            while ((nbytes = input.Read(buffer, 0, buffer.Length)) > 0) {
                response.OutputStream.Write(buffer, 0, nbytes);
            }

            //if (!File.Exists(fname)) return all;
            try {
                TextReader tr = new StreamReader(fname);
                try {
                    for (; true; ) {
                        string inbf = tr.ReadLine();
                        if (inbf == null) break;
                        string[] p = inbf.Split("~\r\n".ToCharArray(), StringSplitOptions.RemoveEmptyEntries);
                        if (p.Count() < 2) continue;
                        all.Set(clib.simple_decode(p[0]), clib.simple_decode(p[1]));
                    }
                }
                catch (Exception e) {
                    clib.imsg("load failed {0}", e.ToString());
                }
                tr.Close();
            }


*/


            tr.Close();
            op.Close();
        }

        class Worker
        {
            private HttpListenerContext context;

            public Worker(HttpListenerContext context)
            {
                this.context = context;
            }

            public void Process()
            {
                if(true){
                    string filename = context.Request.Url.AbsolutePath;     // "/­a=b&b=c"
                    string sb = "<html><body>Hi <b>There</b> :-)</body></html>";
                    byte[] b = Encoding.UTF8.GetBytes(sb);
                    Thread.Sleep(10000);
                    context.Response.OutputStream.Write(b, 0, b.Length);
                } else {
                    string filename = context.Request.Url.AbsolutePath;
                    Console.WriteLine(filename);
                    filename = filename.Substring(1);
                    if (string.IsNullOrEmpty(filename))
                        filename = "index.html";
                    filename = Path.Combine(rootDirectory, filename);
                    Stream input = new FileStream(filename, FileMode.Open);
                    byte[] buffer = new byte[1024 * 16];
                    int nbytes;
                    while ((nbytes = input.Read(buffer, 0, buffer.Length)) > 0)
                        context.Response.OutputStream.Write(buffer, 0, nbytes);
                    input.Close();
                }
                context.Response.OutputStream.Close();
            }
        }
        static private void web_redirect(HttpListenerContext context, string url)
        {
//        var finalUrl = "/cm/demo/basic.html";//ctx.Request.Url.ToString().ToLower().Replace(_originalUrls[i], replacingPrefix);
            context.Response.Redirect(url);
            context.Response.StatusCode = 302;
            context.Response.OutputStream.Close();
            return;
        }
        static private void web_badfile(HttpListenerContext context)
        {
            context.Response.StatusCode = 404;
            context.Response.OutputStream.Close();
            return;
        }

        // Add functiona above here
    }
}
//QQQQQ