// Define search commands. Depends on dialog.js or another
// implementation of the openDialog method.

// Replace works a little oddly -- it will do the replace on the next
// Ctrl-G (or whatever is bound to findNext) press. You prevent a
// replace by making sure the match is no longer selected when hitting
// Ctrl-G.

(function() {
  function SearchState() {
    this.posFrom = this.posTo = this.query = null;
    this.marked = [];
  }
  function getSearchState(cm) {
    return cm._searchState || (cm._searchState = new SearchState());
  }
  function dialog(cm, text, shortText, f) {
    if (cm.openDialog) cm.openDialog(text, f);
    else f(prompt(shortText, ""));
  }
  function confirmDialog(cm, text, shortText, fs) {
    if (cm.openConfirm) cm.openConfirm(text, fs);
    else if (confirm(shortText)) fs[0]();
  }
  function parseQuery(query) {
    var isRE = query.match(/^\/(.*)\/$/);
    return isRE ? new RegExp(isRE[1]) : query;
  }
  var queryDialog =
    'Search: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>';
  function doSearch(cm, rev) {
//    debugger
    var state = getSearchState(cm);
    // QQQ Search
    var xx=cm.getSelection();
    if(!state.query && xx || state.query != xx) {
        clearSearch(cm);
        state.query = parseQuery(xx);
		state.posFrom = state.posTo = cm.getCursor();
    }
    if (state.query) return findNext(cm, rev);
    dialog(cm, queryDialog, "Search for:", function(query) {
      cm.operation(function() {
        if (!query || state.query) return;
        state.query = parseQuery(query);
//        if (cm.lineCount() < 2000) { // This is too expensive on big documents.
//          for (var cursor = cm.getSearchCursor(query); cursor.findNext();)
//            state.marked.push(cm.markText(cursor.from(), cursor.to(), "CodeMirror-searching"));
//        }
        state.posFrom = state.posTo = cm.getCursor();
        findNext(cm, rev);
      });
    });
  }
  function doSearchFiles(cm, rev) {	// QQQ FILES
  	var el=document.getElementById('search_results');
	var txt=prompt("search files","defaultvalue");
	
	var old_val=editor2.getValue();
	var pre,res,post;
	pre='Searching for: ['+txt+']';
	res='lib\\util\\search.js(2): // implementation of the openDialog method.\n\
	lib\\util\\search.js(18): if (cm.openDialog) cm.openDialog(text, f);';
	if(true){
		post='Found 1 occurrence(s) in 1 file(s) ['+txt+']'
	}else{
		post='No matches found ['+txt+']';
	}
	editor2.setValue(old_val+'\n'+pre+'\n'+res+'\n'+post+'\n');
	
	var el=editor2.getScrollerElement()
	el.scrollTop=el.scrollHeight;

	return;
  	el.innerHTML+='<br>'+
  		'lib\\util\\dialog.js(20): var inp = dialog.getElementsByTagName("input")[0]; <br>'+
		'lib\\util\\dialog.js(38): var buttons = dialog.getElementsByTagName("button") <br>'+
		'lib\\util\\loadmode.js(30): var others = document.getElementsByTagName("script")[0]; <br>'+
		'test\\test.js(4): var te = document.getElementById("code"); <br>'+
		'test\\test.js(90): var place = document.getElementById("testground"), cm = CodeMirror(place);<br>';
	el.scrollTop=el.scrollHeight;
  }
  function open_file(cm)
  {
//	var old_val=editor.getValue();
//	editor.setValue('foo \n'+old_val);
	tabs=dge('tabs');
	var frag=document.createElement("a");
	frag.innerHTML='Foo.cs';
	tabs.appendChild(frag);
	tab_file(cm);
  }
  function tab_file(cm)
  {
	var txt='', file='', mode ='';
	if(!cm.file_count) cm.file_count=0;
	cm.file_count++;
	switch(cm.file_count%6){
		case 0: txt = '<html>\n<body><h1>Stuff</h1>\n more stuff\n</body>\n</html>'; file='demo/basic.html'; mode ='text/html'; break;
		case 1: txt = 'function(){\n	var aa=bb;\n}'; file='mwedit.js'; mode="javascript"; break;
		case 2: txt = 'Some other text\n more text\n'; file='LICENSE'; mode=''; break;
		case 3: txt = 'Some other text\n more text\n'; file='WebServer.cs'; mode='text/x-csharp'; break;
		case 4: txt = 'Some other text\n more text\n'; file='theme/mwedit.css'; mode='text/x-hcomment'; break;
		case 5: txt = 'Some other text\n more text\n'; file='email.txt'; mode='text/x-email'; break;

	}
//	editor.setValue(txt);//'content of file '+cm.file_count);
//	dge("filename").value='/usr/local/somewhere/file'+cm.file_count+suffix;
	
	sndReq('/files/'+xescape(file),function(ch){
			if (ch.status!=200){
				alert('badness '+ch.status);
			}else{
				editor.setOption('mode', mode);
				editor.setValue(ch.responseText);
			}
		});
  }
  function findNext(cm, rev) {cm.operation(function() {
    var state = getSearchState(cm);
    var cursor = cm.getSearchCursor(state.query, rev ? state.posFrom : state.posTo);
    if (!cursor.find(rev)) {
      cursor = cm.getSearchCursor(state.query, rev ? {line: cm.lineCount() - 1} : {line: 0, ch: 0});
      if (!cursor.find(rev)) return;
    }
    cm.setSelection(cursor.from(), cursor.to());
    state.posFrom = cursor.from(); state.posTo = cursor.to();
  })}
  function clearSearch(cm) {cm.operation(function() {
    var state = getSearchState(cm);
    if (!state.query) return;
    state.query = null;
    for (var i = 0; i < state.marked.length; ++i) state.marked[i].clear();
    state.marked.length = 0;
  })}

  var replaceQueryDialog =
    'Replace: <input type="text" style="width: 10em"/> <span style="color: #888">(Use /re/ syntax for regexp search)</span>';
  var replacementQueryDialog = 'With: <input type="text" style="width: 10em"/>';
  var doReplaceConfirm = "Replace? <button>Yes</button> <button>No</button> <button>Stop</button>";
  function replace(cm, all) {	// QQREPLACE
    dialog(cm, replaceQueryDialog, "Replace:", function(query) {
      if (!query) return;
      query = parseQuery(query);
      dialog(cm, replacementQueryDialog, "Replace with:", function(text) {
        if (all) {
          cm.compoundChange(function() { cm.operation(function() {
            for (var cursor = cm.getSearchCursor(query); cursor.findNext();) {
              if (typeof query != "string") {
                var match = cm.getRange(cursor.from(), cursor.to()).match(query);
                cursor.replace(text.replace(/\$(\d)/, function(w, i) {return match[i];}));
              } else cursor.replace(text);
            }
          })});
        } else {
          clearSearch(cm);
          var cursor = cm.getSearchCursor(query, cm.getCursor());
          function advance() {
            var start = cursor.from(), match;
            if (!(match = cursor.findNext())) {
              cursor = cm.getSearchCursor(query);
              if (!(match = cursor.findNext()) ||
                  (cursor.from().line == start.line && cursor.from().ch == start.ch)) return;
            }
            cm.setSelection(cursor.from(), cursor.to());
            confirmDialog(cm, doReplaceConfirm, "Replace?",
                          [function() {doReplace(match);}, advance]);
          }
          function doReplace(match) {
            cursor.replace(typeof query == "string" ? text :
                           text.replace(/\$(\d)/, function(w, i) {return match[i];}));
            advance();
          }
          advance();
        }
      });
    });
  }

  CodeMirror.commands.find = function(cm) {clearSearch(cm); doSearch(cm);};
  CodeMirror.commands.findNext = doSearch;
  CodeMirror.commands.findPrev = function(cm) {doSearch(cm, true);};
  CodeMirror.commands.clearSearch = clearSearch;
  CodeMirror.commands.replace = replace;
  CodeMirror.commands.findMulti = function(cm) {clearSearch(cm); doSearchFiles(cm);};;
  CodeMirror.commands.openFile = function(cm) {open_file(cm);};
  CodeMirror.commands.tabFile = function(cm) {tab_file(cm);/*e_stop(window.event);*/};

  CodeMirror.commands.findNextMulti = doSearch;
  CodeMirror.commands.findPrevMulti = function(cm) {doSearch(cm, true);};
  
  CodeMirror.commands.replaceAll = function(cm) {replace(cm, true);};
  

})();



